//More information at: https://www.aeq-web.com/
//Sensor check for LoRaWAN Weatherstation

#include <Wire.h>
#include <Adafruit_Sensor.h>
#include <Adafruit_BME280.h>

#include <U8x8lib.h>

int ldrpin = 37; //PIN for LDR input
int anopin = 36; //PIN for anemometer input

float temp;
float pressure;
float humidity;
float sunlight;
float wind;

int wind_cnt;

Adafruit_BME280 bme;
U8X8_SSD1306_128X64_NONAME_SW_I2C u8x8(15, 4, 16);

void setup() {
  delay(1000);
  pinMode(anopin, INPUT_PULLDOWN);
  bme.begin(0x76); //define I2C-address
  u8x8.begin();
  u8x8.setFont(u8x8_font_chroma48medium8_r);
  u8x8.drawString(2, 4, "SENSOR TEST");
  delay(5000);
}

void loop() {
  getSensorData();

  u8x8.clear();
  u8x8.setCursor(0, 1);
  u8x8.print("Temp: ");
  u8x8.print(temp);
  u8x8.print(" *C ");

  u8x8.setCursor(0, 2);
  u8x8.print("Pres: ");
  u8x8.print(pressure);
  u8x8.print(" hpa");

  u8x8.setCursor(0, 3);
  u8x8.print("Hum: ");
  u8x8.print(humidity);
  u8x8.print(" %");

  u8x8.setCursor(0, 4);
  u8x8.print("Sun: ");
  u8x8.print(sunlight);
  u8x8.print(" %");

  u8x8.setCursor(0, 5);
  u8x8.print("Wind: ");
  u8x8.print(wind);
  u8x8.print(" km/h"); 

  delay(1000);
}

void getSensorData() {
  temp = bme.readTemperature();
  pressure = bme.readPressure() / 100;
  humidity = bme.readHumidity();

  int LDRValue = analogRead(ldrpin);
  sunlight = (LDRValue * 0.02442);

  meassure_wind();
}

void meassure_wind() {
  wind_cnt = 0;
  attachInterrupt(anopin, intrrupt_cnt, RISING);
  delay(3000); //Time for measure counts
  detachInterrupt(anopin);
  wind = ((float)wind_cnt / (float)3 * 2.4) / 2; //Convert counts & time to km/h
}

void intrrupt_cnt() {//On count detected
  wind_cnt++;//Add one count
}
