//More information at: https://www.aeq-web.com/
//Sensor check for LoRaWAN Weatherstation

#include <Wire.h>
#include <Adafruit_Sensor.h>
#include <Adafruit_BME280.h>

int ldrpin = 37; //PIN for LDR input
int anopin = 36; //PIN for anemometer input

float temp;
float pressure;
float humidity;
float sunlight;
float wind;

int wind_cnt;

Adafruit_BME280 bme;

void setup() {
  delay(5000);
  Serial.begin(115200);
  pinMode(anopin, INPUT_PULLDOWN);
  bme.begin(0x76); //define I2C-address
}

void loop() {
  getSensorData();

  Serial.print("Temp: ");
  Serial.print(temp);
  Serial.print(" *C Pressure: ");
  Serial.print(pressure);
  Serial.print(" hpa Humidity: ");
  Serial.print(humidity);
  Serial.print(" % Sun: ");
  Serial.print(sunlight);
  Serial.print(" % Wind: ");
  Serial.print(wind);
  Serial.println(" km/h");

  delay(1000);
}

void getSensorData() {
  temp = bme.readTemperature();
  pressure = bme.readPressure() / 100;
  humidity = bme.readHumidity();

  int LDRValue = analogRead(ldrpin);
  sunlight = (LDRValue * 0.02442);

  meassure_wind();
}

void meassure_wind() {
  wind_cnt = 0;
  attachInterrupt(anopin, intrrupt_cnt, RISING);
  delay(3000); //Time for measure counts
  detachInterrupt(anopin);
  wind = ((float)wind_cnt / (float)3 * 2.4) / 2; //Convert counts & time to km/h
}

void intrrupt_cnt() {//On count detected
  wind_cnt++;//Add one count
}
